//This add-on requires the "Hammer" tool to load. You're probably not going to be missing that... Just keep it in mind.
//Made by sluggy (bl-id 5412), and agaly at a time of before. Referencing of other scripts did occur (e.g Iban's existences and default add-ons).

datablock AudioProfile(airhammersound)
{
   filename    = "./airhammersound.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(airhammerExplosion : hammerExplosion)
{
   soundProfile = airhammersound;
};

datablock ProjectileData(airhammerProjectile)
{
   directDamage        = 0;
   directDamageType  = $DamageType::airhammer;
   radiusDamageType  = $DamageType::airhammer;
   explosion           = airhammerExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "1 0.5 0 1";

   uiName = "Airhammer";
};


//////////
// item //
//////////
datablock ItemData(airhammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./airhammer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Airhammer";
	iconName = "./icon_Airhammer";
	doColorShift = false;
	colorShiftColor = "1 0.5 0 1";

	 // Dynamic properties defined by the scripts
	image = airhammerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(airhammerImage)
{

   shapeFile = "./airhammer.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
 
   correctMuzzleVector = turn;

   eyeOffset = "0 0 0";

   className = "WeaponImage";

   item = Item;
   ammo = " ";
   projectile = airhammerProjectile;
   projectileType = Projectile;

   melee = true;
   doRetraction = false;

   armReady = true;

   doColorShift = false;
   colorShiftColor = "1 0.5 0 1";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.75;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateSequence[3]                = "Fire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
};

function airhammerImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, wrench);
	Parent::onFire(%this,%obj,%slot);	

   //%obj.setImageTrigger(1,1);
}

function airhammerProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	if((%col.getType() & $typeMasks::playerObjectType) && isObject(%col.client))
	{	

		%col.setplayerscale("1 1 0.35");
		%col.schedule(3000,setScale, "1 1 1");
	}
}